# ***********************************************************************
# Licensed Material - Property of IBM
#
# 
#
# (c) Copyright IBM Corp. 2009.  All rights reserved.
#
# US Government Users Restricted Rights - Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
# ************************************************************************
##################################################################
#
# Deploys Healthcare ICP ears.
#
# #######################################################################
import sys
import java
#########################################################################
# Load properties from file
#########################################################################
print
print "Reading configuration properties ..."
from java.util import Properties
from java.io import FileInputStream
from java.io import FileOutputStream
from java.io import OutputStreamWriter
from java.lang import System
from java.lang import Boolean
from java.lang import Integer
from java.lang import String
from java.lang import System
from com.ibm.wbimonitor.lifecycle.spi.mbeans import RESTSecurityAdminMBeanFactory

propFile = "config.properties"
fis = FileInputStream(propFile)
prop = Properties()
prop.load(fis)
print prop
#########################################################################
# Get Monitor Model and ear properties
#########################################################################
print
print "Loading Monitor Model configurations ..."
mmAppName = prop.getProperty('mmAppName')
mmEarFileName = prop.getProperty('mmEarFileName')
refEarAppName = prop.getProperty('refEarAppName')
refEarFileName = prop.getProperty('refEarFileName')
mockAppName = prop.getProperty('mockAppName')
mockEarFileName = prop.getProperty('mockEarFileName')
print "Configuration properties loaded."
#########################################################################
# Get User and Group properties
#########################################################################
print
print "Loading User and Group configurations ..."
groupName = prop.getProperty('groupName')
groupNameJayWalkSupervisor = prop.getProperty('groupNameJayWalkSupervisor')
groupNameDavidCampPA = prop.getProperty('groupNameDavidCampPA')
groupNameBonnieDanielLOBManager = prop.getProperty('groupNameBonnieDanielLOBManager')
userName01AdamProvider = prop.getProperty('userName01AdamProvider')
userName02JayWalkSupervisor = prop.getProperty('userName02JayWalkSupervisor')
surName01 = prop.getProperty('surName01')
surName02 = prop.getProperty('surName02')
userName03DavidCampPA = prop.getProperty('userName03DavidCampPA')
userName04BonnieDanielLOBManager = prop.getProperty('userName04BonnieDanielLOBManager')
surName03 = prop.getProperty('surName03')
surName04 = prop.getProperty('surName04')
#########################################################################
# Get connected cell/node/server name
#########################################################################
print
print "Reading server configuration ..."
cell = AdminControl.getCell();
print cell
node = AdminControl.getNode();
print node
wsadminServer =AdminControl.queryNames("node=" + node + ",type=Server,*" )
server = AdminControl.getAttribute(wsadminServer, "name" )
print server
#######################################################################
##########################################################################
# Get CEI configuration options
#########################################################################
print
print "Loading CEI configurations ..."

serverLocation = prop.getProperty('serverLocation')
hostName = prop.getProperty('hostName')
rmiPort = prop.getProperty('rmiPort')
soapPort = prop.getProperty('soapPort')
securityMode = prop.getProperty('securityMode')
userid = prop.getProperty('userid')
password = prop.getProperty('password')
eventGroup = prop.getProperty('eventGroup')
cellName = prop.getProperty('cellName')
nodeName = prop.getProperty('nodeName')
serverName = prop.getProperty('serverName')
clusterName = prop.getProperty('clusterName')
distributionMode = prop.getProperty('distributionMode')
createCubes = prop.getProperty('createCubes')
startCubes = prop.getProperty('startCubes')
businessSituation = prop.getProperty('businessSituation')
profileMigration = prop.getProperty('profileMigration')
#
#######################################################################
# Def - Uninstalling the Existing Application
#######################################################################

def unInstallApplications(appList):
    installedApps = AdminApp.list().splitlines()
    try:
        for app in appList:
            if(app in installedApps):
                print "Uninstalling "+ app
                AdminApp.uninstall(app)
		AdminConfig.save()
    except:
        print "Exception:Error while uninstalling "+ app
        sys.stderr.write("Exception:Error while uninstalling "+ app)
        raise
AdminConfig.save()
#######################################################################
# Uninstalling the Existing Monitor Model Application(s)
#######################################################################

print "The order is: "     
fabricApplicationList = [refEarAppName, mockAppName, mmAppName]
print "The List of uninstallable: " + str(fabricApplicationList)

unInstallApplications(fabricApplicationList)

#########################################################################
# Creating user and group and their mapping
#########################################################################
print
print "Creating Group and user Name and their mapping ..."
try :
        
	attrGrp = ["-cn",groupName]
	if(len(AdminTask.searchGroups(attrGrp)) > 1):
	    print "Skipping creating group " +  groupName + " as group exists"
	else :
	    AdminTask.createGroup(attrGrp)
	attrGrpSupervisor = ["-cn",groupNameJayWalkSupervisor]
	if(len(AdminTask.searchGroups(attrGrpSupervisor)) > 1):
	    print "Skipping creating group " +  groupNameJayWalkSupervisor + " as group exists"
	else :
	    AdminTask.createGroup(attrGrpSupervisor)
	attrGrpProviderAdministrator = ["-cn",groupNameDavidCampPA]
	if(len(AdminTask.searchGroups(attrGrpProviderAdministrator)) > 1):
	    print "Skipping creating group " +  groupNameDavidCampPA + " as group exists"
	else :
	    AdminTask.createGroup(attrGrpProviderAdministrator)
	attrGrpLOBManager = ["-cn",groupNameBonnieDanielLOBManager]
	if(len(AdminTask.searchGroups(attrGrpLOBManager)) > 1):
	    print "Skipping creating group " +  groupNameBonnieDanielLOBManager + " as group exists"
	else :
	    AdminTask.createGroup(attrGrpLOBManager)
	attrName1 = ["-uid",userName01AdamProvider]
	if(len(AdminTask.searchUsers(attrName1)) > 1):
            print "Skipping creating user " +  userName01AdamProvider + " as user exists"
	else :
	    appOptions = ["-uid", userName01AdamProvider, "-password", "password", "-confirmPassword", "password", "-cn", userName01AdamProvider, "-sn", surName01]
	    AdminTask.createUser(appOptions)
	    attrName1 = ["-uid",userName01AdamProvider]
	    userStr1 = AdminTask.searchUsers(attrName1)
	    groupStr = AdminTask.searchGroups(attrGrp)
	    appOptions = ["-memberUniqueName", userStr1, "-groupUniqueName",groupStr]
 	    AdminTask.addMemberToGroup(appOptions)
	attrName2 = ["-uid",userName02JayWalkSupervisor]
	if(len(AdminTask.searchUsers(attrName2)) > 1):
            print "Skipping creating user " +  userName02JayWalkSupervisor + " as user exists"
	else :
	    appOptions = ["-uid", userName02JayWalkSupervisor, "-password", "password", "-confirmPassword", "password", "-cn", userName02JayWalkSupervisor, "-sn", surName02]
	    AdminTask.createUser(appOptions)
	    attrName2 = ["-uid",userName02JayWalkSupervisor]
	    userStr2 =  AdminTask.searchUsers(attrName2)
	    groupStr = AdminTask.searchGroups(attrGrpSupervisor)
	    appOptions = ["-memberUniqueName", userStr2,"-groupUniqueName",groupStr ]
 	    AdminTask.addMemberToGroup(appOptions)
	attrName3 = ["-uid",userName03DavidCampPA]
	if(len(AdminTask.searchUsers(attrName3)) > 1):
            print "Skipping creating user " +  userName03DavidCampPA + " as user exists"
	else :
	    appOptions = ["-uid", userName03DavidCampPA, "-password", "password", "-confirmPassword", "password", "-cn", userName03DavidCampPA, "-sn", surName03]
	    AdminTask.createUser(appOptions)
	    attrName3 = ["-uid",userName03DavidCampPA]
	    userStr3 = AdminTask.searchUsers(attrName3)
	    groupStr = AdminTask.searchGroups(attrGrpProviderAdministrator)
	    appOptions = ["-memberUniqueName", userStr3, "-groupUniqueName",groupStr]
 	    AdminTask.addMemberToGroup(appOptions)
	attrName4 = ["-uid",userName04BonnieDanielLOBManager]
	if(len(AdminTask.searchUsers(attrName4)) > 1):
            print "Skipping creating user " +  userName04BonnieDanielLOBManager + " as user exists"
	else :
	    appOptions = ["-uid", userName04BonnieDanielLOBManager, "-password", "password", "-confirmPassword", "password", "-cn", userName04BonnieDanielLOBManager, "-sn", surName04]
	    AdminTask.createUser(appOptions)
	    attrName4 = ["-uid",userName04BonnieDanielLOBManager]
	    userStr4 = AdminTask.searchUsers(attrName4)
	    groupStr = AdminTask.searchGroups(attrGrpLOBManager)
	    appOptions = ["-memberUniqueName", userStr4, "-groupUniqueName",groupStr]
 	    AdminTask.addMemberToGroup(appOptions)	
except :
        print "Exception:Error occured while Group user creation and mapping"
        sys.stderr.write("Error occured while Group user creation and mapping")
        raise
        print "Group groupName"

#########################################################################
# Creating user and group and their mapping done
#########################################################################
#Deploy the Healthcare application
#########################################################################
# Install Ref app EAR
#########################################################################
print
print "Installing Reference Implementation application ..."
try :
        appOptions = ["-appname", refEarAppName, "-server", serverName]
	AdminApp.install(refEarFileName, appOptions)

except :
        print "Exception:Error occured while deploying refEarAppName"
        sys.stderr.write("Error occured while deploying refEarAppName")
        raise
        print "Deployed Reference Implemention."

# Save the app
AdminConfig.save()
appManager = AdminControl.queryNames('type=ApplicationManager,*')
print "The appManager is: " + appManager
AdminControl.invoke(appManager, 'startApplication', refEarAppName)
print "Ear started: " + refEarAppName
print refEarAppName + " installed successfully."
#########################################################################
# Install Common Services application EAR
#########################################################################
print
#########################################################################
# Install Healthcare Mock Services EAR
#########################################################################
print
print "Installing Healthcare Mock Services EAR (HPCP_RTCA_Mock_Service) ..."
try :
        appOptions = ["-appname", mockAppName, "-server", serverName]
	AdminApp.install(mockEarFileName, appOptions)

except :
        print "Exception:Error occured while deploying mockAppName"
        sys.stderr.write("Error occured while deploying mockAppName")
        raise
        print "Deployed Healthcare Mock Services EAR (HPCP_RTCA_Mock_Service)."

# Save the app
AdminConfig.save()
appManager = AdminControl.queryNames('type=ApplicationManager,*')
print "The appManager is: " + appManager
AdminControl.invoke(appManager, 'startApplication', mockAppName)
print "Ear started: " + mockAppName
print mockAppName + " installed successfully."
#########################################################################
# Install Monitor Model EARs
#########################################################################
print
print "Installing Monitor Model application ..."

# The LifecycleClientDatabaseTask task consists of the following 6 fields
# and the acceptable values:
#   "Run scripts to create the schema" = yes or no
#   "Run scripts to enable Data Movement Services" = yes or no
#   "Run scripts to delete the schema during uninstallation" = yes or no
#   "Processing strategy" = SerialST or SerialMT
#   "Enable event reordering" = yes or no
#   "Enable KPI merge from previous version" = yes or no
createSchema = 'yes'
enableDMS = 'no'
deleteSchema = 'yes'
processingStrategy = 'SerialMT'
eventReordering = 'no'
kpiMerge = 'no'
businessSituation = 'yes'
profileMigration = 'no'

 # Alphablox settings

 # 1.  The LifecycleClientAlphabloxTask task consists of the following 8 fields
 # 2. and the acceptable values:
 # 3. "Server location (local/remote)" = local or remote
 # 4. default is local
 # 5. "Host name, ignored if location is local"= hostname
 # 6. "RMI port, ignored if location is local" = port number
 # 7. "Security (enabled/disabled), ignored if location is local" = enabled or disabled
 # 8. default is disabled
 # 9. "User ID, ignored if security is disabled" = user ID
 # 10. "Password, ignored if security is disabled" = password
 # 11. "Create the Alphablox cubes" = yes or no
 # 12. default is yes if Alphablox is local
 # 13. "Start the Alphablox cubes" = should be the same value as "Create the Alphablox cubes"
serverLocation = 'local'
hostName = ''
rmiPort = ''
securityMode = 'enabled'
userid = 'admin'
password = 'admin'
createCubes = 'yes'
startCubes = 'yes'

databaseTaskInfo = [ createSchema, enableDMS, deleteSchema, processingStrategy, eventReordering, kpiMerge, businessSituation, profileMigration ]
alphabloxTaskInfo = [ serverLocation, hostName, rmiPort, securityMode, userid, password, createCubes, startCubes ]

print AdminControl.trace('com.ibm.wbimonitor.*=all=enabled')

print
print "Installing Monitor Model application ..."
# Install Monitor Model EAR
if serverLocation == 'local':
   cellName = cell
   nodeName = node
   serverName = server
elif serverLocation == 'remote':
   print "Installing Monitor Model on remote Monitor server..." 
else:
   print "Please set CEI server location in configration properties file"
   sys.exit(1)

ceiTaskInfo = [ serverLocation, hostName, rmiPort, securityMode, userid, password, \
   eventGroup, cellName, nodeName, serverName, clusterName, distributionMode ]
try :
	AdminApp.install(mmEarFileName,  ['-LifecycleClientDatabaseTask', [databaseTaskInfo], \
	'-LifecycleClientAlphabloxTask', [alphabloxTaskInfo], \
	'-LifecycleClientCEITask', [ceiTaskInfo], '-appname', mmAppName]  )

except :
        print "Exception:Error occured while deploying mmAppName"
        sys.stderr.write("Error occured while deploying mmAppName")
        raise
        print "Deployed Monitor Model ears."

# Save the app
AdminConfig.save()
try :
    appManager = AdminControl.queryNames('type=ApplicationManager,*')
    AdminControl.invoke(appManager, 'startApplication', mmAppName)
    print "Ear started: " + mmAppName
except :
    print "Please start the " + mmAppName + " application manually using WPS Administration console."

#########################################################################
# Monitor Model Role Mapping begins.
#########################################################################

AdminControl.trace( 'com.ibm.wbimonitor.*=all=enabled' )  

rest_mbean = RESTSecurityAdminMBeanFactory.getMBean( AdminControl.getAdminClient() )
print 'RESTSecurityAdminMBean.toString=' + rest_mbean.toString()

#The return type is a boolean 'true' or 'false'


result = rest_mbean.assignRoleToUserOnResourceGroup("uid="+userName01AdamProvider+",o=defaultWIMFileBasedRealm","root","Business-Manager","user")
if (result==1) :
    print "User "+ userName01AdamProvider + "successfully mapped to role Business-Manager" 
else :
    print "Failed to map user " + userName01AdamProvider + "to role Business-Manager"

result = rest_mbean.assignRoleToUserOnResourceGroup("uid="+userName01AdamProvider+",o=defaultWIMFileBasedRealm","root","Personal-KPI-Administrator","user")
if (result==1) :
    print "User "+ userName01AdamProvider + "successfully mapped to role Personal-KPI-Administrator" 
else :
    print "Failed to map user " + userName01AdamProvider + "to role Personal-KPI-Administrator"

result = rest_mbean.assignRoleToUserOnResourceGroup("uid="+userName01AdamProvider+",o=defaultWIMFileBasedRealm","root","Public-KPI-Administrator","user")
if (result==1) :
    print "User "+ userName01AdamProvider + "successfully mapped to role Public-KPI-Administrator" 
else :
    print "Failed to map user " + userName01AdamProvider + "to role Public-KPI-Administrator"

result = rest_mbean.assignRoleToUserOnResourceGroup("uid="+userName01AdamProvider+",o=defaultWIMFileBasedRealm","root","KPI-Administrator","user")
if (result==1) :
    print "User "+ userName01AdamProvider + "successfully mapped to role KPI-Administrator" 
else :
    print "Failed to map user " + userName01AdamProvider + "to role KPI-Administrator"




result = rest_mbean.assignRoleToUserOnResourceGroup("uid="+userName02JayWalkSupervisor+",o=defaultWIMFileBasedRealm","root","Business-Manager","user")
if (result==1) :
    print "User "+ userName02JayWalkSupervisor + "successfully mapped to role Business-Manager" 
else :
    print "Failed to map user " + userName02JayWalkSupervisor + "to role Business-Manager"

result = rest_mbean.assignRoleToUserOnResourceGroup("uid="+userName02JayWalkSupervisor+",o=defaultWIMFileBasedRealm","root","Personal-KPI-Administrator","user")
if (result==1) :
    print "User "+ userName02JayWalkSupervisor + "successfully mapped to role Personal-KPI-Administrator" 
else :
    print "Failed to map user " + userName02JayWalkSupervisor + "to role Personal-KPI-Administrator"

result = rest_mbean.assignRoleToUserOnResourceGroup("uid="+userName02JayWalkSupervisor+",o=defaultWIMFileBasedRealm","root","Public-KPI-Administrator","user")
if (result==1) :
    print "User "+ userName02JayWalkSupervisor + "successfully mapped to role Public-KPI-Administrator" 
else :
    print "Failed to map user " + userName02JayWalkSupervisor + "to role Public-KPI-Administrator"

result = rest_mbean.assignRoleToUserOnResourceGroup("uid="+userName02JayWalkSupervisor+",o=defaultWIMFileBasedRealm","root","KPI-Administrator","user")
if (result==1) :
    print "User "+ userName02JayWalkSupervisor + "successfully mapped to role KPI-Administrator" 
else :
    print "Failed to map user " + userName02JayWalkSupervisor + "to role KPI-Administrator"




result = rest_mbean.assignRoleToUserOnResourceGroup("uid="+userName03DavidCampPA+",o=defaultWIMFileBasedRealm","root","Business-Manager","user")
if (result==1) :
    print "User "+ userName03DavidCampPA + "successfully mapped to role Business-Manager" 
else :
    print "Failed to map user " + userName03DavidCampPA + "to role Business-Manager"

result = rest_mbean.assignRoleToUserOnResourceGroup("uid="+userName03DavidCampPA+",o=defaultWIMFileBasedRealm","root","Personal-KPI-Administrator","user")
if (result==1) :
    print "User "+ userName03DavidCampPA + "successfully mapped to role Personal-KPI-Administrator" 
else :
    print "Failed to map user " + userName03DavidCampPA + "to role Personal-KPI-Administrator"

result = rest_mbean.assignRoleToUserOnResourceGroup("uid="+userName03DavidCampPA+",o=defaultWIMFileBasedRealm","root","Public-KPI-Administrator","user")
if (result==1) :
    print "User "+ userName03DavidCampPA + "successfully mapped to role Public-KPI-Administrator" 
else :
    print "Failed to map user " + userName03DavidCampPA + "to role Public-KPI-Administrator"

result = rest_mbean.assignRoleToUserOnResourceGroup("uid="+userName03DavidCampPA+",o=defaultWIMFileBasedRealm","root","KPI-Administrator","user")
if (result==1) :
    print "User "+ userName03DavidCampPA + "successfully mapped to role KPI-Administrator" 
else :
    print "Failed to map user " + userName03DavidCampPA + "to role KPI-Administrator"



result = rest_mbean.assignRoleToUserOnResourceGroup("uid="+userName04BonnieDanielLOBManager+",o=defaultWIMFileBasedRealm","root","Business-Manager","user")
if (result==1) :
    print "User "+ userName04BonnieDanielLOBManager + "successfully mapped to role Business-Manager" 
else :
    print "Failed to map user " + userName04BonnieDanielLOBManager + "to role Business-Manager"

result = rest_mbean.assignRoleToUserOnResourceGroup("uid="+userName04BonnieDanielLOBManager+",o=defaultWIMFileBasedRealm","root","Personal-KPI-Administrator","user")
if (result==1) :
    print "User "+ userName04BonnieDanielLOBManager + "successfully mapped to role Personal-KPI-Administrator" 
else :
    print "Failed to map user " + userName04BonnieDanielLOBManager + "to role Personal-KPI-Administrator"

result = rest_mbean.assignRoleToUserOnResourceGroup("uid="+userName04BonnieDanielLOBManager+",o=defaultWIMFileBasedRealm","root","Public-KPI-Administrator","user")
if (result==1) :
    print "User "+ userName04BonnieDanielLOBManager + "successfully mapped to role Public-KPI-Administrator" 
else :
    print "Failed to map user " + userName04BonnieDanielLOBManager + "to role Public-KPI-Administrator"

result = rest_mbean.assignRoleToUserOnResourceGroup("uid="+userName04BonnieDanielLOBManager+",o=defaultWIMFileBasedRealm","root","KPI-Administrator","user")
if (result==1) :
    print "User "+ userName04BonnieDanielLOBManager + "successfully mapped to role KPI-Administrator" 
else :
    print "Failed to map user " + userName04BonnieDanielLOBManager + "to role KPI-Administrator"

#########################################################################
# Monitor Model Role Mapping is done.
#########################################################################
#######################################################################
# #Save configuration
#######################################################################
AdminConfig.save()
print "All the configurations are saved .."