# ***********************************************************************
# Licensed Material - Property of IBM
#
# 
#
# (c) Copyright IBM Corp. 2009.  All rights reserved.
#
# US Government Users Restricted Rights - Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
# ************************************************************************
##################################################################
#
# Uninstalls Healthcare ICP ears, deletes Users and Groups.
#
# #######################################################################
import sys
import java
#########################################################################
# Load properties from file
#########################################################################
print
print "Reading configuration properties ..."
from java.util import Properties
from java.io import FileInputStream
from java.io import FileOutputStream
from java.io import OutputStreamWriter
from java.lang import System
from java.lang import Boolean
from java.lang import Integer
from java.lang import String
from com.ibm.wbimonitor.lifecycle.spi.mbeans import RESTSecurityAdminMBeanFactory

propFile = "config.properties"
fis = FileInputStream(propFile)
prop = Properties()
prop.load(fis)
print prop
#########################################################################
# Get Monitor Model and ear properties
#########################################################################
print
print "Loading Monitor Model configurations ..."
mmAppName = prop.getProperty('mmAppName')
mmEarFileName = prop.getProperty('mmEarFileName')
refEarAppName = prop.getProperty('refEarAppName')
refEarFileName = prop.getProperty('refEarFileName')
mockAppName = prop.getProperty('mockAppName')
mockEarFileName = prop.getProperty('mockEarFileName')
print "Configuration properties loaded."
#########################################################################
# Get User and Group properties
#########################################################################
print
print "Loading User and Group configurations ..."
groupName = prop.getProperty('groupName')
groupNameJayWalkSupervisor = prop.getProperty('groupNameJayWalkSupervisor')
groupNameDavidCampPA = prop.getProperty('groupNameDavidCampPA')
groupNameBonnieDanielLOBManager = prop.getProperty('groupNameBonnieDanielLOBManager')
userName01AdamProvider = prop.getProperty('userName01AdamProvider')
userName02JayWalkSupervisor = prop.getProperty('userName02JayWalkSupervisor')
surName01 = prop.getProperty('surName01')
surName02 = prop.getProperty('surName02')
userName03DavidCampPA = prop.getProperty('userName03DavidCampPA')
userName04BonnieDanielLOBManager = prop.getProperty('userName04BonnieDanielLOBManager')
surName03 = prop.getProperty('surName03')
surName04 = prop.getProperty('surName04')
#########################################################################
# Get connected cell/node/server name
#########################################################################
print
print "Reading server configuration ..."
cell = AdminControl.getCell();
print cell
node = AdminControl.getNode();
print node
wsadminServer =AdminControl.queryNames("node=" + node + ",type=Server,*" )
server = AdminControl.getAttribute(wsadminServer, "name" )
print server
#######################################################################
##########################################################################
# Get CEI configuration options
#########################################################################
print
print "Loading CEI configurations ..."

serverLocation = prop.getProperty('serverLocation')
hostName = prop.getProperty('hostName')
rmiPort = prop.getProperty('rmiPort')
soapPort = prop.getProperty('soapPort')
securityMode = prop.getProperty('securityMode')
userid = prop.getProperty('userid')
password = prop.getProperty('password')
eventGroup = prop.getProperty('eventGroup')
cellName = prop.getProperty('cellName')
nodeName = prop.getProperty('nodeName')
serverName = prop.getProperty('serverName')
clusterName = prop.getProperty('clusterName')
distributionMode = prop.getProperty('distributionMode')
#
#######################################################################
# Def - Uninstalling the Existing Application
#######################################################################

def unInstallApplications(appList):
    installedApps = AdminApp.list().splitlines()
    try:
        for app in appList:
            if(app in installedApps):
                print "Uninstalling "+ app
                AdminApp.uninstall(app)
		AdminConfig.save()
    except:
        print "Exception:Error while uninstalling "+ app
        sys.stderr.write("Exception:Error while uninstalling "+ app)
        raise
AdminConfig.save()
#######################################################################
# Uninstalling the Existing Monitor Model Application(s)
#######################################################################

print "The order is: "     
fabricApplicationList = [mmAppName]
print "The List of uninstallable: " + str(fabricApplicationList)

unInstallApplications(fabricApplicationList)
#########################################################################
# Deleting users, groups and their mapping
#########################################################################
print
print "Deleting users, groups and their mapping ..."
try :
	attrName1 = ["-uid",userName01AdamProvider]
	if(len(AdminTask.searchUsers(attrName1)) > 1):
	    print "Deleting user with group " +  userName01AdamProvider
	    userStr1 =  AdminTask.searchUsers(attrName1)
	    attrGrp = ["-cn",groupName]
	    groupStr = AdminTask.searchGroups(attrGrp)
	    appOptions = ["-memberUniqueName", userStr1,"-groupUniqueName",groupStr ]
	    AdminTask.removeMemberFromGroup(appOptions)
	    print "Removed member "  +  userName01AdamProvider + " from group"
	    appOptions = ["-uniqueName", userStr1]
	    AdminTask.deleteUser(appOptions)
	    print "Deleted user " +  userName01AdamProvider
	    groupStr = AdminTask.searchGroups(attrGrp)
	    appOptions = ["-uniqueName",groupStr ]
	    AdminTask.deleteGroup(appOptions)
	    print "Deleted group " +  groupName
	else :
	    print "User " + userName01AdamProvider + " does not exist" 

	attrName2 = ["-uid",userName02JayWalkSupervisor]
	if(len(AdminTask.searchUsers(attrName2)) > 1):
	    print "Deleting user with group " +  userName02JayWalkSupervisor
	    userStr2 =  AdminTask.searchUsers(attrName2)
	    attrGrp = ["-cn",groupNameJayWalkSupervisor]
	    groupStr = AdminTask.searchGroups(attrGrp)
	    appOptions = ["-memberUniqueName", userStr2,"-groupUniqueName",groupStr ]
	    AdminTask.removeMemberFromGroup(appOptions)
	    print "Removed member from group " +  userName02JayWalkSupervisor
	    appOptions = ["-uniqueName", userStr2]
	    AdminTask.deleteUser(appOptions)
	    print "Deleted user " +  userName02JayWalkSupervisor
	    groupStr = AdminTask.searchGroups(attrGrp)
	    appOptions = ["-uniqueName",groupStr ]
	    AdminTask.deleteGroup(appOptions)
	    print "Deleted group " +  groupNameJayWalkSupervisor
	else :
	    print "User " + userName02JayWalkSupervisor + " does not exist"

	attrName3 = ["-uid",userName03DavidCampPA]
	if(len(AdminTask.searchUsers(attrName3)) > 1):
	    print "Deleting user with group " +  userName03DavidCampPA
	    userStr3 =  AdminTask.searchUsers(attrName3)
	    attrGrp = ["-cn",groupNameDavidCampPA]
	    groupStr = AdminTask.searchGroups(attrGrp)
	    appOptions = ["-memberUniqueName", userStr3,"-groupUniqueName",groupStr ]
	    AdminTask.removeMemberFromGroup(appOptions)
	    print "Removed member "  +  userName03DavidCampPA + " from group"
	    appOptions = ["-uniqueName", userStr3]
	    AdminTask.deleteUser(appOptions)
	    print "Deleted user " +  userName03DavidCampPA
	    groupStr = AdminTask.searchGroups(attrGrp)
	    appOptions = ["-uniqueName",groupStr ]
	    AdminTask.deleteGroup(appOptions)
	    print "Deleted group " +  groupNameDavidCampPA
	else :
	    print "User " + userName03DavidCampPA + " does not exist" 

	attrName4 = ["-uid",userName04BonnieDanielLOBManager]
	if(len(AdminTask.searchUsers(attrName4)) > 1):
	    print "Deleting user with group " +  userName04BonnieDanielLOBManager
	    userStr4 =  AdminTask.searchUsers(attrName4)
	    attrGrp = ["-cn",groupNameBonnieDanielLOBManager]
	    groupStr = AdminTask.searchGroups(attrGrp)
	    appOptions = ["-memberUniqueName", userStr4,"-groupUniqueName",groupStr ]
	    AdminTask.removeMemberFromGroup(appOptions)
	    print "Removed member from group " +  userName04BonnieDanielLOBManager
	    appOptions = ["-uniqueName", userStr4]
	    AdminTask.deleteUser(appOptions)
	    print "Deleted user " +  userName04BonnieDanielLOBManager
	    groupStr = AdminTask.searchGroups(attrGrp)
	    appOptions = ["-uniqueName",groupStr ]
	    AdminTask.deleteGroup(appOptions)
	    print "Deleted group " +  groupNameBonnieDanielLOBManager
	else :
	    print "User " + userName04BonnieDanielLOBManager + " does not exist"

except :
        print "Exception:Error occured while deleting users, groups and their mapping "
        sys.stderr.write("Error occured while deleting users, groups and their mapping ")
        raise
        	
#########################################################################
# Monitor Model Role Mapping removal begins.
#########################################################################

AdminControl.trace( 'com.ibm.wbimonitor.*=all=enabled' )  

rest_mbean = RESTSecurityAdminMBeanFactory.getMBean( AdminControl.getAdminClient() )
print 'RESTSecurityAdminMBean.toString=' + rest_mbean.toString()

#The return type is a boolean 'true' or 'false'


result = rest_mbean.removeRole("uid="+userName01AdamProvider+",o=defaultWIMFileBasedRealm","Business-Manager","root")
if (result==1) :
    print "User "+ userName01AdamProvider + "successfully unmapped from role Business-Manager" 
else :
    print "Failed to unmap user " + userName01AdamProvider + "to role Business-Manager"

result = rest_mbean.removeRole("uid="+userName01AdamProvider+",o=defaultWIMFileBasedRealm","Personal-KPI-Administrator","root")
if (result==1) :
    print "User "+ userName01AdamProvider + "successfully unmapped from role Personal-KPI-Administrator" 
else :
    print "Failed to unmap user " + userName01AdamProvider + "to role Personal-KPI-Administrator"

result = rest_mbean.removeRole("uid="+userName01AdamProvider+",o=defaultWIMFileBasedRealm","Public-KPI-Administrator","root")
if (result==1) :
    print "User "+ userName01AdamProvider + "successfully unmapped from role Public-KPI-Administrator" 
else :
    print "Failed to unmap user " + userName01AdamProvider + "to role Public-KPI-Administrator"

result = rest_mbean.removeRole("uid="+userName01AdamProvider+",o=defaultWIMFileBasedRealm","KPI-Administrator","root")
if (result==1) :
    print "User "+ userName01AdamProvider + "successfully unmapped from role KPI-Administrator" 
else :
    print "Failed to unmap user " + userName01AdamProvider + "to role KPI-Administrator"




result = rest_mbean.removeRole("uid="+userName02JayWalkSupervisor+",o=defaultWIMFileBasedRealm","Business-Manager","root")
if (result==1) :
    print "User "+ userName02JayWalkSupervisor + "successfully unmapped from role Business-Manager" 
else :
    print "Failed to unmap user " + userName02JayWalkSupervisor + "to role Business-Manager"

result = rest_mbean.removeRole("uid="+userName02JayWalkSupervisor+",o=defaultWIMFileBasedRealm","Personal-KPI-Administrator","root")
if (result==1) :
    print "User "+ userName02JayWalkSupervisor + "successfully unmapped from role Personal-KPI-Administrator" 
else :
    print "Failed to unmap user " + userName02JayWalkSupervisor + "to role Personal-KPI-Administrator"

result = rest_mbean.removeRole("uid="+userName02JayWalkSupervisor+",o=defaultWIMFileBasedRealm","Public-KPI-Administrator","root")
if (result==1) :
    print "User "+ userName02JayWalkSupervisor + "successfully unmapped from role Public-KPI-Administrator" 
else :
    print "Failed to unmap user " + userName02JayWalkSupervisor + "to role Public-KPI-Administrator"

result = rest_mbean.removeRole("uid="+userName02JayWalkSupervisor+",o=defaultWIMFileBasedRealm","KPI-Administrator","root")
if (result==1) :
    print "User "+ userName02JayWalkSupervisor + "successfully unmapped from role KPI-Administrator" 
else :
    print "Failed to unmap user " + userName02JayWalkSupervisor + "to role KPI-Administrator"




result = rest_mbean.removeRole("uid="+userName03DavidCampPA+",o=defaultWIMFileBasedRealm","Business-Manager","root")
if (result==1) :
    print "User "+ userName03DavidCampPA + "successfully unmapped from role Business-Manager" 
else :
    print "Failed to unmap user " + userName03DavidCampPA + "to role Business-Manager"

result = rest_mbean.removeRole("uid="+userName03DavidCampPA+",o=defaultWIMFileBasedRealm","Personal-KPI-Administrator","root")
if (result==1) :
    print "User "+ userName03DavidCampPA + "successfully unmapped from role Personal-KPI-Administrator" 
else :
    print "Failed to unmap user " + userName03DavidCampPA + "to role Personal-KPI-Administrator"

result = rest_mbean.removeRole("uid="+userName03DavidCampPA+",o=defaultWIMFileBasedRealm","Public-KPI-Administrator","root")
if (result==1) :
    print "User "+ userName03DavidCampPA + "successfully unmapped from role Public-KPI-Administrator" 
else :
    print "Failed to unmap user " + userName03DavidCampPA + "to role Public-KPI-Administrator"

result = rest_mbean.removeRole("uid="+userName03DavidCampPA+",o=defaultWIMFileBasedRealm","KPI-Administrator","root")
if (result==1) :
    print "User "+ userName03DavidCampPA + "successfully unmapped from role KPI-Administrator" 
else :
    print "Failed to unmap user " + userName03DavidCampPA + "to role KPI-Administrator"




result = rest_mbean.removeRole("uid="+userName04BonnieDanielLOBManager+",o=defaultWIMFileBasedRealm","Business-Manager","root")
if (result==1) :
    print "User "+ userName04BonnieDanielLOBManager + "successfully unmapped from role Business-Manager" 
else :
    print "Failed to unmap user " + userName04BonnieDanielLOBManager + "to role Business-Manager"

result = rest_mbean.removeRole("uid="+userName04BonnieDanielLOBManager+",o=defaultWIMFileBasedRealm","Personal-KPI-Administrator","root")
if (result==1) :
    print "User "+ userName04BonnieDanielLOBManager + "successfully unmapped from role Personal-KPI-Administrator" 
else :
    print "Failed to unmap user " + userName04BonnieDanielLOBManager + "to role Personal-KPI-Administrator"

result = rest_mbean.removeRole("uid="+userName04BonnieDanielLOBManager+",o=defaultWIMFileBasedRealm","Public-KPI-Administrator","root")
if (result==1) :
    print "User "+ userName04BonnieDanielLOBManager + "successfully unmapped from role Public-KPI-Administrator" 
else :
    print "Failed to unmap user " + userName04BonnieDanielLOBManager + "to role Public-KPI-Administrator"

result = rest_mbean.removeRole("uid="+userName04BonnieDanielLOBManager+",o=defaultWIMFileBasedRealm","KPI-Administrator","root")
if (result==1) :
    print "User "+ userName04BonnieDanielLOBManager + "successfully unmapped from role KPI-Administrator" 
else :
    print "Failed to unmap user " + userName04BonnieDanielLOBManager + "to role KPI-Administrator"

#########################################################################
# Monitor Model Role Mapping removed.
#########################################################################
AdminConfig.save()